program example;
uses STArduino;
const
	LEFTENCODERCHANNELB 	= 5;
	LEFTENCODERCHANNELA 	= 3;
	RIGHTENCODERCHANNELB 	= 6;
	RIGHTENCODERCHANNELA	= 2;
var 
	leftEncoderCounter : longint;
	rightEncoderCounter  : longint;


procedure leftEncoderIntFunc;      // interrupt function
begin   
	if(digitalRead(LEFTENCODERCHANNELB)=HIGH)   then
  		leftEncoderCounter := leftEncoderCounter - 1 
	else                                        
		leftEncoderCounter := leftEncoderCounter + 1;  
	
	serialPrintlnLong(leftEncoderCounter);         
	
end;

procedure leftEncoderConfig; 
begin
	
	pinMode(LEFTENCODERCHANNELA,INPUT);
  	pinMode(LEFTENCODERCHANNELB,INPUT);
  	attachInterrupt(digitalPinToInterrupt(LEFTENCODERCHANNELA), leftEncoderIntFunc, RISING); // RISING: ngắt xung cạnh lên
end;

procedure rightEncoderIntFunc;
begin   
  if(digitalRead(RIGHTENCODERCHANNELB) = HIGH)    then
  	rightEncoderCounter := rightEncoderCounter + 1
  else                                 
  	rightEncoderCounter := rightEncoderCounter - 1;  
  	serialPrintString('Right encoder counter: ');  
  	serialPrintlnLong(rightEncoderCounter);               
end;

procedure rightEncoderConfig;
begin
	pinMode(RIGHTENCODERCHANNELA,INPUT);
  	pinMode(RIGHTENCODERCHANNELB, INPUT);
  	attachInterrupt(digitalPinToInterrupt(RIGHTENCODERCHANNELA), rightEncoderIntFunc, RISING);      // RISING: ngắt xung cạnh lên
end;

procedure setup;
begin
	leftEncoderCounter:=0;
	rightEncoderCounter := 0;
	serialBegin(115200);
	leftEncoderConfig;
	//rightEncoderConfig;
end;

procedure loop;
begin
end;

begin
end.
