program example;
uses STArduino;
const         
	
	LEFTMOTORINB    	=  12;		// điều hướgg động cơ
	LEFTMOTORINA    	=  11;		// điều hướgg động cơ
	LEFTMOTOREN    		=  13;		// điều chỉnh tốc độ động cơ
	
	LEFTENCODERCHANNELB =  7;		// encoder B
	LEFTENCODERCHANNELA =  2;		// encoder A

var 
	leftEncoderCounter : longint;
	VanToc : real;
	lastEncoderCounter : longint;
	testTime : longint;
procedure leftEncoderIntFunc;
begin
	
	if (digitalRead(LEFTENCODERCHANNELB) = HIGH) then
		leftEncoderCounter := leftEncoderCounter + 1
	else
		leftEncoderCounter := leftEncoderCounter - 1;
	
end;

procedure leftEncoderConfig;
begin
	pinMode(LEFTENCODERCHANNELA,INPUT);
  	pinMode(LEFTENCODERCHANNELB,INPUT);
  	attachInterrupt(digitalPinToInterrupt(LEFTENCODERCHANNELA), leftEncoderIntFunc, RISING);      // RISING: ngắt xung cạnh lên, leftEncoderIntFunc: tên hàm ngắt
end;

procedure setup;
begin
	pinMode(LEFTMOTORINB, OUTPUT);
  	pinMode(LEFTMOTORINA, OUTPUT);
  	pinMode(LEFTMOTOREN, OUTPUT);
  	
	leftEncoderCounter := 0;
	leftEncoderConfig;
	serialBegin(115200);
	lastEncoderCounter := 0;
	testTime := 0;
end;

function motorSpeed:real;
var 
	
	counter : longint;
	speed : real;
begin

		counter := leftEncoderCounter - lastEncoderCounter;
		lastEncoderCounter := leftEncoderCounter;
		motorSpeed:= counter * 1.6968;
		
end;

procedure loop;
begin
	analogWrite(LEFTMOTOREN, 255);    // động cơ trái quay 100%
  	digitalWrite(LEFTMOTORINA,LOW);
  	digitalWrite(LEFTMOTORINB,HIGH);
	if (millis - testTime > 80) then
	begin
		testTime	:= millis;	  	
  		serialPrintlnReal(motorSpeed);
  	end;
end;

begin
end.
